--- C:/Users/Daninet/Desktop/hu-old.js	Wed Jul 13 13:19:51 2011
+++ C:/Users/Daninet/Desktop/hu.js	Wed Jul 13 13:35:37 2011
@@ -34,7 +34,7 @@
 	editorTitle : 'HTML szerkesztő',
 
 	// ARIA descriptions.
-	toolbars	: 'Editor toolbars', // MISSING
+	toolbars	: 'Szerkesztő Eszköztár',
 	editor		: 'HTML szerkesztő',
 
 	// Toolbar buttons without dialogs.
@@ -56,7 +56,7 @@
 	superscript		: 'Felső index',
 	horizontalrule	: 'Elválasztóvonal beillesztése',
 	pagebreak		: 'Oldaltörés beillesztése',
-	pagebreakAlt		: 'Page Break', // MISSING
+	pagebreakAlt		: 'Oldaltörés',
 	unlink			: 'Hivatkozás törlése',
 	undo			: 'Visszavonás',
 	redo			: 'Ismétlés',
@@ -121,11 +121,11 @@
 		alignBottom		: 'Aljára',
 		invalidHeight	: 'A magasság mezőbe csak számokat írhat.',
 		invalidWidth	: 'A szélesség mezőbe csak számokat írhat.',
-		invalidCssLength	: 'Value specified for the "%1" field must be a positive number with or without a valid CSS measurement unit (px, %, in, cm, mm, em, ex, pt, or pc).', // MISSING
-		invalidHtmlLength	: 'Value specified for the "%1" field must be a positive number with or without a valid HTML measurement unit (px or %).', // MISSING
+		invalidCssLength	: '"%1"-hez megadott érték csakis egy pozitív szám lehet, esetleg egy érvényes CSS egységgel megjelölve(px, %, in, cm, mm, em, ex, pt, or pc).',
+		invalidHtmlLength	: '"%1"-hez megadott érték csakis egy pozitív szám lehet, esetleg egy érvényes HTML egységgel megjelölve(px or %).',
 
 		// Put the voice-only part of the label in the span.
-		unavailable		: '%1<span class="cke_accessibility">, unavailable</span>' // MISSING
+		unavailable		: '%1<span class="cke_accessibility">, nem elérhető</span>'
 	},
 
 	contextmenu :
@@ -184,7 +184,7 @@
 		cssClasses		: 'Stíluskészlet',
 		charset			: 'Hivatkozott tartalom kódlapja',
 		styles			: 'Stílus',
-		rel			: 'Relationship', // MISSING
+		rel			: 'Kapcsolat típusa',
 		selectAnchor		: 'Horgony választása',
 		anchorName		: 'Horgony név szerint',
 		anchorId			: 'Azonosító szerint',
@@ -204,7 +204,7 @@
 		title		: 'Horgony tulajdonságai',
 		name		: 'Horgony neve',
 		errorName	: 'Kérem adja meg a horgony nevét',
-		remove		: 'Remove Anchor' // MISSING
+		remove		: 'Horgony eltávolítása'
 	},
 
 	// List style dialog
@@ -604,11 +604,11 @@
 
 	iframe :
 	{
-		title		: 'IFrame Properties', // MISSING
-		toolbar		: 'IFrame', // MISSING
-		noUrl		: 'Please type the iframe URL', // MISSING
-		scrolling	: 'Enable scrollbars', // MISSING
-		border		: 'Show frame border' // MISSING
+		title		: 'IFrame Tulajdonságok',
+		toolbar		: 'IFrame', 
+		noUrl		: 'Kérem írja be a iframe URL-t',
+		scrolling	: 'Gördítősáv bekapcsolása',
+		border		: 'Legyen keret'
 	},
 
 	font :
@@ -717,8 +717,8 @@
 	{
 		title		: 'CKEditor névjegy',
 		dlgTitle	: 'CKEditor névjegy',
-		help	: 'Check $1 for help.', // MISSING
-		userGuide : 'CKEditor User\'s Guide', // MISSING
+		help	: 'Itt találsz segítséget: $1',
+		userGuide : 'CKEditor Felhasználói útmutató', 
 		moreInfo	: 'Licenszelési információkért kérjük látogassa meg weboldalunkat:',
 		copy		: 'Copyright &copy; $1. Minden jog fenntartva.'
 	},
@@ -730,8 +730,8 @@
 	{
 		anchor		: 'Horgony',
 		flash		: 'Flash animáció',
-		iframe		: 'IFrame', // MISSING
-		hiddenfield	: 'Hidden Field', // MISSING
+		iframe		: 'IFrame',
+		hiddenfield	: 'Rejtett mezõ',
 		unknown		: 'Ismeretlen objektum'
 	},
 
@@ -751,17 +751,17 @@
 
 	toolbarGroups :
 	{
-		document : 'Document', // MISSING
-		clipboard : 'Clipboard/Undo', // MISSING
-		editing : 'Editing', // MISSING
-		forms : 'Forms', // MISSING
-		basicstyles : 'Basic Styles', // MISSING
-		paragraph : 'Paragraph', // MISSING
-		links : 'Links', // MISSING
-		insert : 'Insert', // MISSING
-		styles : 'Styles', // MISSING
-		colors : 'Colors', // MISSING
-		tools : 'Tools' // MISSING
+		document : 'Dokumentum', 
+		clipboard : 'Vágólap/Visszavonás', 
+		editing : 'Szerkesztés',
+		forms : 'Űrlapok', 
+		basicstyles : 'Alapstílusok',
+		paragraph : 'Bekezdés', 
+		links : 'Hivatkozások', 
+		insert : 'Beszúrás',
+		styles : 'Stílusok',
+		colors : 'Színek',
+		tools : 'Eszközök'
 	},
 
 	bidi :
@@ -774,14 +774,14 @@
 	{
 		label : 'Dokumentum tulajdonságai',
 		title : 'Dokumentum tulajdonságai',
-		design : 'Design', // MISSING
+		design : 'Design', 
 		meta : 'Meta adatok',
 		chooseColor : 'Válasszon',
 		other : '<más>',
 		docTitle :	'Oldalcím',
 		charset : 	'Karakterkódolás',
 		charsetOther : 'Más karakterkódolás',
-		charsetASCII : 'ASCII', // MISSING
+		charsetASCII : 'ASCII',
 		charsetCE : 'Közép-Európai',
 		charsetCT : 'Kínai Tradicionális (Big5)',
 		charsetCR : 'Cyrill',
@@ -789,7 +789,7 @@
 		charsetJP : 'Japán',
 		charsetKR : 'Koreai',
 		charsetTR : 'Török',
-		charsetUN : 'Unicode (UTF-8)', // MISSING
+		charsetUN : 'Unicode (UTF-8)',
 		charsetWE : 'Nyugat-Európai',
 		docType : 'Dokumentum típus fejléc',
 		docTypeOther : 'Más dokumentum típus fejléc',
@@ -807,6 +807,6 @@
 		metaDescription : 'Dokumentum leírás',
 		metaAuthor : 'Szerző',
 		metaCopyright : 'Szerzői jog',
-		previewHtml : '<p>This is some <strong>sample text</strong>. You are using <a href="javascript:void(0)">CKEditor</a>.</p>' // MISSING
+		previewHtml : '<p>Ez itt egy <strong>példa</strong>. A <a href="javascript:void(0)">CKEditor</a>-t használod.</p>' 
 	}
 };